/*
 * This software licensed under BIXOLON CO LTD
 * Bgate XML Print Demo - Editor support JavaScript
 * Written By Sahaya Darcius P  Apr-12-2016 Bixolon Co Ltd, Pangyo City, South Korea
 * Mail: sahaya@bixolon.kr
*/

var bgtWebPrint = new bGateWebPrintAPI(); 
function deleteFunction()
{
	var index1 = $("#edit-sequence li").index(this);
	$("#edit-sequence li").eq(index1).remove();
	
}
function MakeImage()
{
	var canvas = document.getElementById('myCanvas');
	bgtWebPrint.makeImage(canvas.getContext("2d"), 0, 0, canvas.width, canvas.height);
	
}
function showWEBData()
{
	regexAlign = /^(left|center|right)$/;
	var XMLDATA="";
	
	try 
	{
		$("#edit-sequence li").each(function(p) 
		{
			var m,
			n,
			h,
			w,
			x,
			y,
			z,wd,ht,rot,rev,ics,cp,ul,rev,rot,ud,fnt,bold,lsp,tdata,
			l = $(this);
			n = p + 1;
			if (l.hasClass("text-align")) 
			{
				z = l.find(".align_info").val();
								
				bgtWebPrint.makeAlign({pos:z});
				XMLDATA = bgtWebPrint.xmlData;
			}
			else
			{
				if (l.hasClass("text-print")) 
				{
					fnt  = l.find(".text-font").val();
					ics= l.find(".text-ics").val();
					cp = l.find(".text-code").val();
					wd = l.find(".text-width").val();	
					ht = l.find(".text-height").val();
					y = l.find(".text-ul").is(":checked");
                                        if(y == true)
                                        {
                                        	ul="true";
                                        }
                                        z = l.find(".text-em").is(":checked");
                                        if(z == true)
                                        {
                                        	bold= "true"
                                        }
                                        z = l.find(".text-rot").is(":checked");
                                        if(z == true)
                                        {
                                        	ud = "true"
                                        }
                                        z = l.find(".text-rev").is(":checked");
                                        if(z == true)
                                        {
                                        	rev = "true"
                                        }
                                        
                                       	rot = l.find(".text-rotation").val();
					lsp = l.find(".text-lsp").val();
					tdata=l.find(".text-data").val();
					bgtWebPrint.makeText({data:tdata,ics:ics,code:cp,wd:wd,ht:ht,font:fnt,uline:ul,bold:bold,reverse:rev,updown:ud,rotate:rot,lsp:lsp});
					XMLDATA = bgtWebPrint.xmlData;
				}
				else
				{
					if(l.hasClass("text-cut"))
					{
						z = l.find(".cut-info").val();
						bgtWebPrint.makePaperCut({cuttype:z});
						XMLDATA = bgtWebPrint.xmlData;
					}
					else
					{
						if(l.hasClass("text-feed"))
						{
							z = l.find(".paper-feed").val();
							y = l.find(".feed-val").val();
							bgtWebPrint.makePaperFeed({type:z,value:y});
							XMLDATA = bgtWebPrint.xmlData;
							
						}
						else
						{
							if(l.hasClass("print-barcode"))
							{
								
								
								z = l.find(".barcode-type").val();
								wd = l.find(".barcode-width").val();
								ht = l.find(".barcode-height").val();
								if (wd < 2 || wd > 6) 
								{
									throw new Error("Invalid Barcode Width");
								}
								if (ht < 1 || ht > 255) 
								{
									throw new Error("Invalid Barcode Height");
								}
									
								y=l.find(".barcode-hri").val();
								tdata = l.find(".barcode-data").val();
								bgtWebPrint.makeBarcode12({data:tdata,hri:y,wd:wd,ht:ht,type:z});	
								XMLDATA = bgtWebPrint.xmlData;							
							}
							else
							{
								if(l.hasClass("image-data"))
								{
									var fileInput = l.find(".fileInput").val();
									if(fileInput != "")
									{
										var src = l.find(".image-file").val();										
										var image = new Image();
										image.src = src;											
									
										var canvas = document.getElementById('myCanvas');
										if (canvas.getContext) 
										{
											canvas.width = image.width;
											canvas.height = image.height;
											//alert("canvas.width "+ canvas.width+" canvas.height:"+canvas.height);
											var context = canvas.getContext('2d');
											context.drawImage(image, 0, 0, image.width, image.height);
													
											bgtWebPrint.makeImage(canvas.getContext("2d"), 0, 0, canvas.width, canvas.height);
										}
										
										
										//var canvas = document.getElementById('myCanvas');
										//bgtWebPrint.makeImage(canvas.getContext("2d"), 0, 0, canvas.width, canvas.height);
									}
								}
								else
								{
									if(l.hasClass("cash-draw"))
									{
										
										z = l.find(".connector-info").val();
										y = l.find(".connector-Ontime").val();
										bgtWebPrint.makeDKout({connector:z,duration:y});
										XMLDATA = bgtWebPrint.xmlData;	
									}
									else
									{
										if(l.hasClass("logo-info"))
										{
											z = l.find(".logo-size").val();											
											y = l.find(".key-code").val();
											bgtWebPrint.makeNVlogo({keycode:y,lsize:z});
											XMLDATA = bgtWebPrint.xmlData;									
										}
										else
										{
											if(l.hasClass("reset-info")) 
											{
												bgtWebPrint.makeReinit();
												XMLDATA = bgtWebPrint.xmlData;
											}
											else
											{
												if(l.hasClass("direct-io")) 
												{
													var cmd = [];																								
													cmd = l.find(".command-data").val();
													bgtWebPrint.makeCmd(cmd);
													XMLDATA = bgtWebPrint.xmlData;
												}
												else
												{
													if(l.hasClass("print-qrcode")) 
													{
														z = l.find(".qrcode-model").val();
														wd = l.find(".qrcode-size").val();
														y = l.find(".qrcode-level").val();
														tdata = l.find(".qrcode-data").val();
														bgtWebPrint.makeQRCODE({data:tdata,size:wd,level:y,model:z});
														XMLDATA = bgtWebPrint.xmlData;
													}
													else
													{
														if(l.hasClass("print-pdf417")) 
														{
															z = l.find(".pdf417-mode").val();
															wd = l.find(".pdf417-width").val();
															ht = l.find(".pdf417-height").val();
															y = l.find(".pdf417-level").val();
															tdata = l.find(".pdf417-data").val();
															rot= l.find(".pdf417-row").val();
															cp = l.find(".pdf417-col").val();
															bgtWebPrint.makePDF417({data:tdata,wd:wd,ht:ht,level:y,mode:z,col:cp,row:rot});
															XMLDATA = bgtWebPrint.xmlData;
														}
														else
														{
															if(l.hasClass("buzzer-info")) 
															{
																bgtWebPrint.makeBuzzer();
																XMLDATA = bgtWebPrint.xmlData;
															}
														}
												
													}
												}	
												
											}	
										}
									}
								}
							}
								
						}
					}
	
				}
			}
			
		});
		
		 document.getElementById("xml-doc").value = "ESC/POS Data Successfully Generated";
	}
	
	catch(i) 
	{
		throw new Error("ERROR in PARSING");
	}

	
}



function extract(a) {
    	a.find("button").button({
        icons: {
            primary: "ui-icon-close"
        },
        text: false
    }).click(function() {
	document.getElementById("xml-doc").value = " ";
        a.fadeOut("fast", function() {
            $(this).remove()
            })
        });

	a.find(".image-width").value=10;
	a.find(".image-height").value=10;
	a.find(".image-load").click(function(evt)
	{
		    
		document.getElementById("xml-doc").value = " ";
		a.find(".image-width").val(0);
		a.find(".image-height").val(0);
		
		var src = a.find(".image-file").val();//$(this).val();
		//var cls ='<img  src="' + src + '" class="'+"img-thumbnail" +'"/>';
		var cls = '<img  src="' + src + '" width="'+"50" +'" height="'+"50" + '"/>';
		//alert(cls);
		if(src != 'null') 
		{
			var imgTag = $('<img  src="' + src + '" width="'+"50" +'" height="'+"50" + '"/>');
			//alert("imgTag =" +imgTag);				
			a.find(".ImageDisplayArea").empty().append(/*cls);*/imgTag);
			//img.src = src;			
			
		}
		var image = new Image();
		image.src = src;
		image.onload = function () 
		{
		    var canvas = document.getElementById('myCanvas');
		    if (canvas.getContext) 
		    {
			canvas.width = image.width;
			canvas.height = image.height;
			var context = canvas.getContext('2d');
			context.drawImage(image, 0, 0, image.width, image.height);
			var rem = parseInt(((((image.width) + 31) & ~31) >> 3));	
			var newWidth = rem * 8;
			a.find(".image-width").val(newWidth);
			a.find(".image-height").val(image.height);			
		    }
		}
			
	});
	
}


function sleepFor( sleepDuration ){
    var now = new Date().getTime();
    while(new Date().getTime() < now + sleepDuration){ /* do nothing */ } 
}
			

function printFunction()
{
	
	var ipAddr = document.getElementById('printer-ip').value;	
	var devID  = document.getElementById('devicelist').value;
	var shopID = document.getElementById('shoplist').value;
	
	if(0==ipAddr.length)
	{
		alert("IP Address is not valid.");
		return false;	
	}
	
	if(!isValidIPaddress(ipAddr))
	{
		if(!IsDomainValid(ipAddr))
		{
			alert("IP/Domain is not valid.");
			return false;
		}
		
	}	
	if(0==shopID.length)
	{
		alert("Shop Name is not valid.");
		return false;	
	}
	
	if(0==devID.length)
	{
		alert("Device Name is not valid.");
		return false;	
	}
	
	if(document.getElementById("xml-doc").value == " ")
	showWEBData();
	
	bgtWebPrint.sendData(ipAddr,shopID,devID);
	document.getElementById("xml-doc").value =" ";
	
}

	

function isValidIPaddress(e) {
    return /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(e) ? !0 : !1
}

function IsDomainValid(e) {
    return null == e.match(/^([a-zA-Z0-9]+(([\-]?[a-zA-Z0-9]+)*\.)+)*[a-zA-Z]{2,}$/i) ? !1 : !0
} 

/*
function isValidIPaddress(ipaddress)   
{  
	if (/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(ipaddress))  
	{  
		return (true)  
	}  
	alert("You have entered an invalid IP address!")  
	return (false)  
}
*/
function ShopListGet()
{
	var bgtWebPrint = new bGateWebPrintAPI(); 
	var ipAddr = document.getElementById("printer-ip").value;
	//var ipAddr = "192.168.100.208";//""104.199.197.13"
	if(0==ipAddr.length)
	{
		alert("IP Address is not valid.");
		return false;	
	}
	
	if(!isValidIPaddress(ipAddr))
	{
		if(!IsDomainValid(ipAddr))
		{
			alert("IP/Domain is not valid.");
			return false;
		}
		
	}
	bgtWebPrint.getShopList(ipAddr,"shoplist");
} 

function DeviceListGet()
{
	var bgtWebPrint = new bGateWebPrintAPI(); 
	//var shopID = document.getElementById("shop-id").value;
	var shopID = document.getElementById('shoplist').value;	
	var ipAddr = document.getElementById("printer-ip").value;
	//alert(shopID +" : " + ipAddr);
	if(0==ipAddr.length)
	{
		alert("IP Address is not valid.");
		return false;	
	}
	
	if(!isValidIPaddress(ipAddr))
	{
		if(!IsDomainValid(ipAddr))
		{
			alert("IP/Domain is not valid.");
			return false;
		}
		
	}
	if(0==shopID.length)
	{
		alert("Shop Name is not valid.");
		return false;	
	}
	bgtWebPrint.getDeviceList(ipAddr,shopID,"devicelist");
}



function clearFunction()
{
	if (confirm('Are you sure you want to delete the edit area?')) 
	{
		$("#edit-sequence li").remove();
		$("#edit-left").css({
                    top: 0
                });
		document.getElementById("xml-doc").value = " ";
		
		//location.reload();
		
	} 
	
}

function imageFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".image-data").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
	$("#edit-sequence").append(l); 
	
	extract(l);
}


function allignemtFunction()
{
	document.getElementById("xml-doc").value = " ";
	//$('#allignmentInfo ul').clone().appendTo('#edit-sequence');
	var u = $("#edit-left ul"),l;
	l = u.find(".text-align").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	   
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
	$("#edit-sequence").append(l);
	extract(l);	
}


function textPrintFunction()
{
	document.getElementById("xml-doc").value = " ";
	//$('#allignmentInfo ul').clone().appendTo('#edit-sequence');
	var u = $("#edit-left ul"),l;
	l = u.find(".text-print").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l);
		extract(l); 
}

function barcodeFunction()
{
	document.getElementById("xml-doc").value = " ";
	//$('#allignmentInfo ul').clone().appendTo('#edit-sequence');
	var u = $("#edit-left ul"),l;
	l = u.find(".print-barcode").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
		extract(l);
}

function qrcodeFunction()
{
	document.getElementById("xml-doc").value = " ";
	//$('#allignmentInfo ul').clone().appendTo('#edit-sequence');
	var u = $("#edit-left ul"),l;
	l = u.find(".print-qrcode").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
		extract(l);
}

function pdf417Function()
{
	document.getElementById("xml-doc").value = " ";
	//$('#allignmentInfo ul').clone().appendTo('#edit-sequence');
	var u = $("#edit-left ul"),l;
	l = u.find(".print-pdf417").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
		extract(l);
}

function cutFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".text-cut").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
	extract(l);
}

function feedFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".text-feed").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
	extract(l);
}

function pulseFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".cash-draw").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
	$("#edit-sequence").append(l); 
	extract(l);
}
function logoFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".logo-info").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
	extract(l);
}

function resetFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".reset-info").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
	extract(l);
}

function buzzerFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".buzzer-info").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
	extract(l);
}

function directIOFunction()
{
	document.getElementById("xml-doc").value = " ";
	var u = $("#edit-left ul"),l;
	l = u.find(".direct-io").clone();
	l.find(".edit-content").replaceWith( 
	function() { 
		return $(this).contents();
		}
	);	
	  
	// normalize parent to strip extra text nodes
	l.each(function(element,index){
	    $(this)[0].normalize();
	});
		  $("#edit-sequence").append(l); 
	extract(l);
}

function clearFunction()
{
	if (confirm('Are you sure you want to delete the edit area?')) 
	{
		$("#edit-sequence li").remove();
		$("#edit-left").css({
                    top: 0
                });
		document.getElementById("xml-doc").value = " ";
		
		//location.reload();
		
	} 
	
}

 $("#edit-left li").hover(function() {
        $(this).addClass("ui-state-highlight")
        }, function() {
        $(this).removeClass("ui-state-highlight")
        }).click(function() {
        var g = $(this).clone();
        $("#edit-sequence").append(g);
        extract(g)
        }).draggable({
        connectToSortable: "#edit-sequence",
        helper: "clone"
    });
    $("#edit-sequence").sortable({
        placeholder: "edit-holder",
        update: function(g, h) {
            extract(h.item)
            }
    });



